SystemOrganization addCategory: #'Keymapping-Tools-Spec'!

ComposableModel subclass: #KMDescription
	instanceVariableNames: 'list collectingBlock categories displayList sortingBlock updatingBlock okToolbar dropList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tools-Spec'!

!KMDescription commentStamp: '<historical>' prior: 0!
A KMDescription is a window showing the description of shortcuts for a specified set of symbols reprensenting KMCategories!

!KMDescription class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 8/3/2012 16:09'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
		newColumn: [:c | 
			c 
				newRow: [:r | 
					r 
						add: #dropList;
						add: #displayList ] height: 25;
				add: #list;
				add: #okToolbar height: 25 ]! !

!KMDescription class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 4/6/2012 17:23'!
example

	| d |
	d := KMDescription new.
	d categories: #(GlobalShortcuts MonticelloShortcuts TextEditor).
	d openWithSpec! !

!KMDescription class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 4/6/2012 15:46'!
title

	^ 'Shortcuts description'! !

!KMDescription methodsFor: 'accessing' stamp: 'GuillermoPolito 5/1/2012 12:26'!
categories
	
	^ categories! !

!KMDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/6/2012 15:34'!
categories: aCollectionOfSymbols
	| cats |
	
	cats := aCollectionOfSymbols collect: [:e | KMRepository default categoryForName: e].
	categories contents: cats! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/6/2012 15:38'!
displayList
	
	^ displayList! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/3/2012 16:09'!
dropList
	
	^ dropList! !

!KMDescription methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/6/2012 15:49'!
initialExtent

	^  (600@350)! !

!KMDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 8/3/2012 16:08'!
initialize
	"Initialization code for KMDescription"

	categories := nil asValueHolder.
	super initialize.

	updatingBlock := [:col || dropListItems |
		dropListItems := col collect: [:cat | DropListItem named: cat name do: [| items |
																items := (cat entriesAt: #all) keymaps collect: [:e | collectingBlock value: e ].
																list items:  (items sorted: sortingBlock) ]].
		dropList items: dropListItems ].! !

!KMDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 8/3/2012 16:09'!
initializePresenter
		
	displayList whenSelectedItemChanged: [ updatingBlock value: categories contents ].
	categories whenChangedDo: [:col | updatingBlock value: col ].
	okToolbar okAction: [ self delete ].! !

!KMDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 8/3/2012 16:09'!
initializeWidgets

	self instantiateModels: #(
		#dropList DropListModel
		list MultiColumnListModel
		okToolbar OkToolbar
		displayList DropListModel ).
	
	displayList items: {
		DropListItem 
			named:'shortcut	:	description' 
			do: [ 
					collectingBlock := [:e | {e shortcut asString. ':'. e description asString} ].
					sortingBlock := [:a :b | a first < b first ]].
		DropListItem 
			named:'description	:	shortcut' 
			do: [ 
					collectingBlock := [:e | {e description asString. ':'. e shortcut asString} ].
					sortingBlock := [:a :b | a first < b first ]]}.
	
	list 
		displayBlock: [ :e | e ];
		allowToSelect: false.

	okToolbar okButton
			label: 'Close';
			state: false! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/6/2012 15:00'!
list
	
	^ list! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/3/2012 16:09'!
okToolbar
	
	^ okToolbar! !
